#include <sys/file.h>
#include <sys/stat.h> /* for S_* constants */
#include <string.h> /* for strerror(3) prototype */
#include <stdio.h> /* for fprintf(3),printf(3),stderr protype */
#include <errno.h> /* for errno prototype */
#include <unistd.h> /* for close(2) prototypes */
#define FILENAME "/tmp/flock.example"

int main(int argc,char **argv) {

	int fd; char buf;

	fd = open(FILENAME,O_RDWR|O_CREAT,S_IRUSR|S_IWUSR); if (fd==-1) {

		fprintf(stderr, "open(\"%s\",O_RDWR,S_IRUSR|S_IWUSR): %s (%i)\n", FILENAME, strerror(errno), errno);
		return 1;

	}

	printf("Acquiring lock...");
	fflush(stdout);

	/* Acquire an exclusive lock */

	if (flock(fd, LOCK_EX | LOCK_NB) == -1) {

		fprintf(stderr, "flock(fd,LOCK_EX): %s (%i)\n", strerror(errno), errno);
		return 1;

	}

	printf("Succeeded!\n");
	printf("Press enter to release the lock.\n");

	if (read(0,&buf,sizeof(buf)) == -1) {

		printf("read(0,&buf,sizeof(buf)): %s (%i)\n", strerror(errno), errno );
		return 1;

	}

	printf("Releasing lock...");
	fflush(stdout);

	if (flock(fd,LOCK_UN)==-1) {

		fprintf(stderr, "flock(fd,LOCK_UN): %s (%i)\n", strerror(errno), errno);
		return 1;

	}

	printf("Released!\n");

	if (close(fd)==-1) {

		fprintf(stderr, "close(fd): %s (%i)\n", strerror(errno), errno);
		return 1;

	}

	return 0;

}
